#include "iodefine.h"
#include "wdt0.h"
#include "rtc.h"



#pragma interrupt(WDTimer)		/* 荞݃nh錾 */
void WDTimer(void);
#pragma section VECT25			/* WDT0 ̊荞ݔԍ 25 */
void(*const VECT_TABLE25[])(void)={	/* 荞݃xN^e[uɓo^DCVECT25 ZNV offset 64H ɔzu */
	WDTimer
};


#pragma section		/* ZNVWɖ߂ */

unsigned long timer;
unsigned int laptime;
unsigned char beepcount;


void WDTimer(void)
{
	static unsigned char lastvalue;
	char a;
	
	a=WDT0.READ.TCSR.BYTE;		// OVFNAOɓǂݏoKv
	WDT0.WRITE.TCSR=0xA523;		// OVFNA

	timer+=65535;
	if (timer > 600000000-1)
	{
		timer -=600000000;
	}

	// laptimer;
	a=(timer/100000)%10;	// 1/100b̈̈ʂo
	if(a!=lastvalue)		// 1/100̌ω
	{
		laptime++;
		lastvalue=a;
		
		if(beepcount==0)
		{
			TMR1.TCR.BIT.CKS=0;	// uU[~߂
		}
		else
		{
			beepcount--;
		}
	}

	// v
	a=timer/10000000;	// b
	if (clock.ss!=a)	// bJE^ω
	{
		clock.ss=a;
		if (clock.ss==30) timer += -30000;	//  1Ƃ3000nsx炷
		
		if (clock.ss==0)
		{
			clock.mm++;
			if (clock.mm>59)
			{
				clock.hh++;
				clock.mm=0;
				if (clock.hh>23)
				{
					clock.hh=0;
					RTC_init();	// ߑO 0RTCǂݏo
				}
			}
		}
	}
}
