/*
SST39SF040 f[^V[g

Byte-Program      5555H-AAH 2AAAH-55H 5555H-A0H [Program Byte address]-[Data]
1 oCgPʂŃtbV݂̏s܂B
݂I܂ł́ÃR}hV[PXs邱Ƃł܂B
ݏImFɂ́AtbV̓AhXɑ΂[h߂ 2sA
f[^ǂݍ܂܂Ń|[Os܂B
ݒ̓[hxɃrbg6 ]܂BݎԂ͍ő20us
) Ƀf[^(FFH ܂) ܂ꂽtbṼAhXɑ΂A
ēxf[^݂̏sꍇAZN^C[X܂̓`bvC[XɂāA
Ȃ炸̃AhX̃f[^ɏ݂sĉB

Sector-Erase      5555H-AAH 2AAAH-55H 5555H-80H 5555H-AAH 2AAAH-55H [Sector-Erase; uses A18-A12 address lines]-30H
4K oCgPʂŃtbV̏s܂B
͈͂́AAhX̏7 rbgŎw肵܂BႦ΁AF000H~FFFFH 4K oCgꍇ́A
F000H~FFFFH ̉ꂩ̃AhXw肵܂B
I܂ł́ÃR}hV[PXs邱Ƃł܂B
ImFɂ́AtbV̓AhXɑ΂[h߂2 sA
f[^ǂݍ܂܂Ń|[Os܂B̓[hxɃrbg6 ]܂BԂ͍ő25msB

Chip-Erase        5555H-AAH 2AAAH-55H 5555H-80H 5555H-AAH 2AAAH-55H 5555H-10H
tbV̑S̈܂B
I܂ł́ÃR}hV[PXs邱Ƃł܂B
ImFɂ́AtbV̓AhXɑ΂[h߂2 sA
f[^ǂݍ܂܂Ń|[Os܂B̓[hxɃrbg6 ]܂BԂ͍ő100msB
ȂAꂽ̈̃f[^FFH ƂȂ܂B

Software ID Entry 5555H-AAH 2AAAH-55H 5555H-90H
Software ID Entry sProduct ID [hN܂BNɍő150nsB
Software ID [hAtbVɑ΂ă[h߂sƃx_[ID, tbVIDǂݏoƂł܂B
Software ID[ĥ܂ܓdfSoftware ID[h͏I܂BԂB

0000H-BFH SST Manufacturer's ID
0001H-B5H ST39SF010A Device ID
0001H-B6H SST39SF020A Device ID
0001H-B7H SST39SF040 Device ID

Software ID Exit  XXH-F0H
Software ID Exit  5555H-AAH 2AAAH-55H 5555H-F0H
Software ID [hI܂BIɍő150nsB
*/

#include "eeprom.h"

#define eeprom_5555H	*(volatile unsigned char *)(eeprom_address+0x5555)
#define eeprom_2AAAH	*(volatile unsigned char *)(eeprom_address+0x2AAA)

void eeprom_busycheck(void);

void byte_program(unsigned long address, unsigned char data)
{
	//5555H-AAH 2AAAH-55H 5555H-A0H [Program Byte address]-[Data]
	eeprom_5555H=0xAA;
	eeprom_2AAAH=0x55;
	eeprom_5555H=0xA0;
	*(unsigned char *) address=data;

	eeprom_busycheck();	// ő20usŏȂ̂Ń`FbNsvH
}

void sect_erase(unsigned long address)
{
	unsigned char *a;
	a=(unsigned char *)address;
	// 5555H-AAH 2AAAH-55H 5555H-80H 5555H-AAH 2AAAH-55H [Sector-Erase; uses A18-A12 address lines]-30H
	eeprom_5555H=0xAA;
	eeprom_2AAAH=0x55;
	eeprom_5555H=0x80;
	eeprom_5555H=0xAA;
	eeprom_2AAAH=0x55;
	//*(unsigned char *) address=0x30;
	*a=0x30; // ǂł
	
	eeprom_busycheck();
}

void chip_erase(void)
{
	// 5555H-AAH 2AAAH-55H 5555H-80H 5555H-AAH 2AAAH-55H 5555H-10H
	eeprom_5555H=0xAA;
	eeprom_2AAAH=0x55;
	eeprom_5555H=0x80;
	eeprom_5555H=0xAA;
	eeprom_2AAAH=0x55;
	eeprom_5555H=0x10;
	
	eeprom_busycheck();
}

void eeprom_busycheck(void)
{
	unsigned char a,b;
	unsigned int i;

	a=eeprom_5555H;		// ǂǂł܂Ȃ
	for (i=0; i<10000; i++)
	{
		b=eeprom_5555H;	// Ƃǂ
		if (a==b) break;
		a=b;
	}
}
